#!/usr/bin/python
'''
  # nsreconfig.py, version 1.0
  # (c) 2002-2008 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
  # Licensed under GNU GPLv2+.

  # You can use standard netsaint commands as:
  #   command[...]=...
  # Also you can use varaibles:
  #   var="$1;..."
  # Add to variable:
  #   var+string
  #   - this is replaced by:
  #     var="$var,string" or var="string"
  # Any variable can be user as command:
  #   var param1;param2;...
  # And repetition operator:
  #   @param1;param2;... cmd1,cmd2,...
  #   - this is replaced by:
  #     cmd1 param1;param2;...
  #     cmd2 param1;param2;...
  #     ...
  #   - paramters can be separated by " ", ",", ";"
  # Include file:
  #   <filename
'''

import sys, re

c=[]

def ereg(exp, s, ignore=None):
    global c
    #print exp, s
    r = re.compile(exp).search(s)
    if r:
      c = r.groups()
    return r

def chk(s):
    global cnf,fhost,cmdt,cmds,fx,c
    if ereg('^[<>](.*)$',s):
      # include file
      cnfi=cnf;
      dofile(c[0]);
      cnf=cnfi;
    elif ereg('^[ ]*([a-zA-Z0-9_.]+)=\"?([^"]*)\"?$', s):
      # variable assignment
      cmdt[c[0]]=c[1]
      cmds="%s|%s" % (cmds, c[0])
    elif ereg("^[ ]*([a-zA-Z0-9_.]+)\+(.*)$", s):
      if cmdt.has_key(c[0]):
        cmdt[c[0]] = cmdt[c[0]]+","+c[1]
      else:
        cmdt[c[0]] = c[1]
    elif ereg("^[ ]*(%s)[ \t]*[( ](.*)\)?$" % cmds, s):
      mcmd = cmdt[c[0]]
      margs = c[1].split(";")
      for i in range(1,10):
        if len(margs)>=i:
          mcmd = re.compile("\\$%d" % i).sub(margs[i-1], mcmd)
      for key, value in cmdt.items():
        mcmd = re.compile("\\$%s([^a-zA-Z0-9_]|$)" % key
                          ).sub(value+"\\1", mcmd)
      fhost.write(mcmd+"\n")
    elif ereg("^[ ]*@([-a-zA-Z0-9_;.]*) (.*)$", s):
      ca = re.split("[ ,;]", c[1])
      c0 = c[0]
      for value in ca:
        chk("%s %s" % (value, c0))
    elif ereg("^[ ]*[a-zA-Z0-9_.]*\[", s):
      #print s
      fhost.write(s+"\n")
    elif ereg("^define [a-zA-Z0-9_.]+[ \t]*\{", s):
      #print s
      fhost.write(s+"\n")
    elif s!="":
      print "# Illegal command: '%s'" % s;

def dofile(f):
    global cnf,cmdt,cmds,fhost;
    cnf=open(f,"r")
    s=""
    while True:
        line = cnf.readline()
        if not line: break
        s += re.compile("#.*$").sub("", line.rstrip()) + "\n";
        if ((s.count('"')%2)==0) and (s.count('{')==s.count('}')):
            #break
            chk(s.rstrip())
            s = ""
    cnf.close()

fhost=open(sys.argv[2], "w")
cmdt=dict(echo="$1", _="\n")
cmds="echo"
dofile(sys.argv[1])
fhost.close()
